<?xml-stylesheet type="text/xsl" href="../../../../development/milestone_plans/stylesheets/milestone-bulletList.xsl"?>
<plan>
	<component name="xsd" subproject="wst">
		<description>xml schema tools</description>
		<milestone name="M4">
			<title>M4 Plans (updated 2005-03-18)</title>
			<category name="Overall XSD UI">
                <item priority="high">	
                   <description>Support API for contributing menu items to XSD editor menus</description>
  				   <developer name="kchong@ca.ibm.com" />
                   <step start="3" pds="2"></step> 
                </item>   				
			</category>			
            <category name="Properties View">
				<item priority="low" pds="4">
					<description>Plan/prototype API for specialized <i>annotation</i> editing views</description>
					<developer name="kchong@ca.ibm.com" />					
                    <step start="5" length="1"></step>                     
				</item>
			</category>		
            <category name="XSD Validation">
				<item priority="medium" helpWanted="" status="done">
					<description>Add JUnit tests for XSD validator</description>
                    <developer name="lmandel@ca.ibm.com"/>
                    <step start="6" pds="4"/> 
                </item>  
            </category>
		</milestone>
        <milestone name="M5">
			<title>M5 - under development and review - (updated 2005-03-18)</title>
			<category name="Articles">
				<item priority="medium">
					<description>Article - Introduction to the XML Schema Editor</description>
					<developer name="kchong@ca.ibm.com" />
					<step start="4" length="3" pds="3"></step>
				</item>
			</category>
			<category name="Overall XSD UI">
				<item priority="low" helpWanted="true">
					<description>Implement 'Open Declaration' support</description>					
				</item>	
				<item priority="medium" helpWanted="true">
					<description>Investigate additional API requirements</description>					
				</item>			
				<item priority="low" helpWanted="true">
					<description>Investigate XSD search function to find component refences in XSD, WSDL and XML</description>					
				</item>	
				<item priority="medium" helpWanted="true">
					<description>Provide XML Schema refactoring support</description>
					<developer name="ebelisar@ca.ibm.com" />
					<step>
						<description>Move to 'common' refactoring infrastructure (similar to JDT refactoring)</description>
					</step>		
				</item>
                <item priority="low">
					<description>Improve XML Schema editor reliability</description>
                    <detail>
                           Typically when editing we incrementally update the schema model to sync with the DOM.
                           Sometimes we find ourselves closing/opening the editor to ensure we have a 'clean' state.
                           We need to add some strategic 'checkpoints' where we can do a full 'reconcile' of the model
                           to ensure model is consistent with the document.
                    </detail> 
					<developer name="kchong@ca.ibm.com" />
					<step start="6" pds="2">
						<description>Improve robustness of model/editor synchronization.</description>
					</step>
					<step start="6" pds="2">
						<description>Improve properties/source synchronization.</description>
					</step>
				</item>	          
			</category>	
		</milestone>
		<milestone name="M6?">
			<title>Future - under development and review - (updated 2005-03-07)</title>		
			<category name="Graph View">			               
 			    <item priority="medium">
					<description>Implement visualization of additional objects and relationships</description>
					<developer name="kchong@ca.ibm.com" />
					<step status="investigate" start="4" pds="5">
						<description>Display attributes in graphical view</description>
					</step>				                	
				</item>
                <item>
					<description>Support visualization of additional objects and relationships</description>
					<developer name="kchong@ca.ibm.com" />
					<step start="4" pds="2">
						<description>Display attributes in graphical view</description>
					</step>
					<step  status="investigate">
						<description>Inheritance - allow supertypes/subtypes to be displayed</description>
					</step>     
					<step status="investigate">
						<description>Substitution groups - show 'choice' like object when elements belong to substiution groups</description>
					</step>           
				</item>
                <item priority="medium">
                    <description>Keep history of expansion state to make it more convenient to revisit view</description>                      
                </item>  
 			   <item priority="medium">
					<description>Implement visualization of additional objects and relationships</description>
					<developer name="kchong@ca.ibm.com" />
					<step status="investigate" start="4" pds="5">
						<description>Display attributes in graphical view</description>
					</step>					
				</item>
			</category>
			<category name="Properties View">
				<item priority="medium" helpWanted="true">
					<description>Improve &lt;import&gt; editing</description>
					<developer name="rmah@ca.ibm.com" />
					<step start="5" pds="2">
						<description>Support catalog browsing to locate to schemas</description>
					</step>
				</item>	
				<item priority="low">
					<description>Improve generic support for <i>annotation</i> editing</description>
					<developer name="kchong@ca.ibm.com"/>
					<step start="5">
						<description>Provide support for multiple annotations</description>
					</step>
					<step start="6">
						<description>Provide source editing for XML content</description>
					</step>
					<step start="6">
						<description>Provide tree view for XML content</description>
					</step>
				</item>           
			</category>		
	        <category name="Documentation Generation">
				<item priority="low">
					<description>Improve HTML documention generation</description>
					<developer name="lauzond@ca.ibm.com" />
					<step start="4" pds="2">
						<description>Provide basic documentation generation support</description>
					</step>
					<step start="5" pds="1">
						<description>Refactor for reuse (e.g. so WSDL docgen links seamlessly with XSD docgen)</description>
					</step>
					<step start="6" pds="1">
						<description>Support &lt;annotation&gt; content in gen'd docs</description>
					</step>
				</item>
			</category>
		</milestone>
	</component>
</plan>